var xmlhttp;

//var searching_div;
var searching_flasher;
var results_div;
var resultsborder_div;
var results_in_div;
var notfound_div;
var logo_div;
var restart_div;
var searchfield;

var vers = 1.0;

function setup() {
	searching_flasher = new Flasher(document.getElementById('searching'), .5, 'searching_flasher');
	results_div = document.getElementById('results');
	resultsborder_div = document.getElementById('resultsborder');
	results_in_div = document.getElementById('results_in');
	notfound_div = document.getElementById('notfound');
	logo_div = document.getElementById('logo');
	restart_div = document.getElementById('restart');
	searchfield = document.getElementById('searchfield');
	
	createGenericButton(restart_div, 'Nuova ricerca', restart);
	createGenericButton(document.getElementById('doneButton'), 'Fine', document.getElementById('doneButton').onclick);
	document.getElementById('ourlink').onclick = openInBrowser;
	
	scrollerInited = false;
	
	if(window.widget)
		checkUpdate();
	
	if(window.widget) {
		//widget.onremove = destroy;
		widget.onshow = onshow;
		widget.onhide = onhide;
	}
}

function destroy() {}

var was_flashing;

function onshow() {
	if(was_flashing)
		searching_flasher.start();
	checkUpdate();
}

function onhide() {
	if(was_flashing = !searching_flasher.stopped)
		searching_flasher.stop();
	clearTimeout(checktimer);
}

function showHideBack(show) {
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition(show ? "ToBack" : "ToFront");
	
	if(show) {
		front.style.display="none";
		back.style.display="block";
	}
	else {
		front.style.display="block";
		back.style.display="none";
	}

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function doSearch() {
	if(searchfield.value!='') {
		if (!xmlhttp)
			xmlhttp = new XMLHttpRequest();

		if (!scrollerInited) {
			scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
			scrollerInited = true;
		}
		else {
			cleanup(results_in_div);
		}
		logo_div.style.display = 'none';
		searchfield.style.display = 'none';
		searching_flasher.start();
		results_div.style.display = 'block';
		resultsborder_div.style.display = 'block';
		restart_div.style.display = 'block';

		if(xmlhttp) {
			xmlhttp.open('GET', 'http://www.pensieriparole.it/search.php?q='+escape(searchfield.value)+'&type=rss');
			xmlhttp.onreadystatechange = searchDone;
			xmlhttp.send(null);
		}
	}
}

function searchDone() {
	if (xmlhttp.readyState==4) {
		var entries = xmlhttp.responseXML.documentElement.getElementsByTagName('item');
		var title, link, cat, oldcat, category, arrow, catcontainer;
		if(was_flashing)
			was_flashing = false;
		else
			searching_flasher.stop();
		if(entries.length != 0) {
			for (var i=0; i<entries.length; ++i) {
				title = entries[i].getElementsByTagName('title');
				title = title[0].firstChild.nodeValue;
				link = entries[i].getElementsByTagName('link');
				link = link[0].firstChild.nodeValue;
				cat = entries[i].getElementsByTagName('category');
				cat = cat[0].firstChild.nodeValue;
				
				if(oldcat != cat) {
					category = document.createElement('h2');
					arrow = document.createElement('span');
					arrow.className = 's';
					arrow.onclick = disclosureTriangle;
					category.appendChild( arrow );
					category.appendChild( document.createTextNode(cat) );
					
					if(catcontainer)
						results_in_div.appendChild( catcontainer );
					catcontainer = document.createElement('div');
					
					arrow.theContainer = catcontainer;
					
					results_in_div.appendChild( category );
					oldcat = cat;
				}
				
				catcontainer.appendChild( createResultDiv(title, link) );
			}
			if(catcontainer)
				results_in_div.appendChild( catcontainer );
			calculateAndShowThumb(results_in_div);
		}
		else {
			notfound_div.style.display = 'block';
			calculateAndShowThumb(results_in_div);
		}
	}
}

function allthings(what) {
	var i, r='';
	for (i in what)
		r+=i+' = '+what[i]+'\n';
	return r;
}

function cleanup(what) {
	while(what.firstChild)
		what.removeChild(what.firstChild);
}

function openInBrowser(event) {
	if(window.widget) {
		widget.openURL(this.href);
		return false;
	}
}

function createResultDiv(stitle, slink) {
	var div = document.createElement('div');
	div.className = 'entry';
	
	var title = document.createElement('div');
	title.className = 'title';
	title.appendChild( document.createTextNode(stitle) );
	div.appendChild(title);
	
	var link = document.createElement('a');
	link.href = slink;
	link.onclick = openInBrowser;
	link.appendChild( document.createTextNode('Visualizza nel sito >') );
	div.appendChild(link);
	
	return div;
}

function disclosureTriangle() {
	if(this.className == 's') {
		this.className = '';
		this.theContainer.style.display = 'none';
		calculateAndShowThumb(results_in_div);
	}
	else {
		this.className = 's';
		this.theContainer.style.display = 'block';
		calculateAndShowThumb(results_in_div);
	}
}


var check, checktimer, lastupdatecheck = 0;
function checkUpdate() {
	var d = new Date();

	if(d.getTime() >= lastupdatecheck + 24*3600*1000) { //1 giorno
		if(!check)
			check = new XMLHttpRequest();
	
		if(check) {
			check.open('GET', 'http://www.pensieriparole.it/widget/version.xml');
			check.onreadystatechange = checkUpdateDone;
			check.send(null);
		}
	}
	else
		checktimer = setTimeout('checkUpdate();', 3600000); //1 ora  
}

function checkUpdateDone() {
	if(check.readyState == 4) {
		if(parseFloat(check.responseXML.documentElement.getAttribute('version')) > vers) {
			document.getElementById('update').onclick = openInBrowser;
			document.getElementById('update').innerText = 'Aggiornamento disponibile: '+check.responseXML.documentElement.firstChild.nodeValue;
			document.getElementById('update').style.display = 'block';
		}
		else
			checktimer = setTimeout('checkUpdate();', 3600000); //1 ora
		var d = new Date();
		lastupdatecheck = d.getTime();
	}
}

function restart() {
	if(!searching_flasher.stopped)
		searching_flasher.stop();
	if(xmlhttp.readyState!=0 && xmlhttp.readyState!=4)
		xmlhttp.abort();
	restart_div.style.display = 'none';
	logo_div.style.display = 'block';
	searchfield.style.display = 'block';
	results_div.style.display = 'none';
	resultsborder_div.style.display = 'none';
	notfound_div.style.display = 'none';
	
	searchfield.value = '';
	searchfield.focus();
}

//my class for flashing elements
function Flasher(a, f, v){
	this.elapsed = 0.0;
	this.omega = 2*f*Math.PI;
	this.apply = a;
	this.stopped = true;
	this.varname = v;
	
	this.start = function() {
		this.apply.style.display = 'block';
		this.apply.style.opacity = 1.0;
		this.stopped = false;
		this.elapsed = 0.0;
		window.setTimeout(this.varname+'.timeout()', 50);
	}
	
	this.timeout = function() {
		if(!this.stopped) {
			var v = Math.cos(this.omega * this.elapsed)/2 + .5;
			this.apply.style.opacity = v.toFixed(3);
			this.elapsed += .05;
			window.setTimeout(this.varname+'.timeout()', 50);
		}
	}
	
	this.stop = function() {
		this.apply.style.display = 'none';
		this.stopped = true;
	}
}

//apple's code for the rollie animation
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }

        var starttime = (new Date).getTime() - 13;

        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }

        var starttime = (new Date).getTime() - 13;

        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();


	T = limit_3(time-animation.starttime, 0, animation.duration);

		if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease;
}

function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}